Package com.documentum.fc.client

# Interface IDfQueueItem

All Superinterfaces:
  `IDfPersistentObject`, `IDfTypedObject`

public interface IDfQueueItem extends IDfPersistentObject
This interface contains the functionality to retrieve information from a dmi_queue_item object.

- ## Field Summary

  ### Fields inherited from interface com.documentum.fc.client.IDfPersistentObject

  `CURRENCY_CHECK_ALWAYS, CURRENCY_CHECK_FIRST_ACCESS, CURRENCY_CHECK_NEVER, CURRENCY_CHECK_ONCE_PER_SCOPE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getAContentType()`
  Returns the content type of the routed object.
  `IDfTime`
  `getActualStartDate()`
  Returns the date on which work on the item actually started.
  `String`
  `getContentType()`
  Returns the file format of the object assciated with a router task.
  `IDfTime`
  `getDateSent()`
  Returns the date the work item, task, or event was sent.
  `String`
  `getDependencyType()`
  Returns the dependency type.
  `String`
  `getDequeuedBy()`
  Returns the name of the user who dequeued the item.
  `IDfTime`
  `getDequeuedDate()`
  Returns the date on which the item was dequeued.
  `IDfTime`
  `getDueDate()`
  Returns the date on which the associated work item or task is expected to be completed.
  `String`
  `getEvent()`
  Returns the name of the event.
  `int`
  `getInstructionPage()`
  Returns the instruction page's page number.
  `IDfId`
  `getItemId()`
  Returns the object ID of the package or routed object.
  `String`
  `getItemName()`
  Returns the name of the package associated with the work item or router task.
  `String`
  `getItemType()`
  Returns the object type of the package or routed object.
  `String`
  `getMessage()`
  Returns the message associated with the work item, task, or event notification.
  `String`
  `getName()`
  Returns the name of the queue owner.
  `String`
  `getNextTasksType()`
  Indicates which tasks in the "next tasks list" are queued when this task is forwarded.
  `String`
  `getOperations()`
  Returns the value in the a_operations attribute of the queue item.
  `IDfTime`
  `getPlanStartDate()`
  Returns the expected starting date of the associated router task.
  `double`
  `getPosition()`
  Returns the value in the position attribute.
  `int`
  `getPriority()`
  Returns the priority of the associated work item or task.
  `IDfId`
  `getRouterId()`
  Returns the object ID of the associated workflow or router.
  `String`
  `getSentBy()`
  Returns the name of the user who sent the work item, task, or event notification.
  `IDfTime`
  `getSignOffDate()`
  Returns the date on which the work item or task was signed off.
  `String`
  `getSignOffUser()`
  Returns the name of the user who signed off the item.
  `String`
  `getSourceDocbase()`
  Returns the repository that is the source of the queued object.
  `IDfId`
  `getSourceEvent()`
  Returns the object ID of the queued item in the source repository.
  `int`
  `getSourceStamp()`
  Returns the vstamp value of the source queue item.
  `IDfId`
  `getStamp()`
  Returns the object ID of the queue item object.
  `String`
  `getSupervisorName()`
  Returns the name of the workflow or router supervisor.
  `String`
  `getTargetDocbase()`
  Returns the name of the target repository.
  `String`
  `getTaskName()`
  Returns the value in the task_name attribute.
  `String`
  `getTaskNumber()`
  Returns the activity's sequence number if this is work item or the task number if this is a router task.
  `String`
  `getTaskState()`
  Returns the state of the associated work item or router task.
  `String`
  `getTaskSubject()`
  Returns a subject for the task inbox item
  `String`
  `getTaskType()`
  Returns the type of the activity or task associated with the queued item.
  `IDfWorkitem`
  `getWorkitem()`
  Returns the work item object associated with the queue item.
  `boolean`
  `isDeleteFlag()`
  Indicates whether the queued item has been dequeued.
  `boolean`
  `isReadFlag()`
  Indicates whether the queued item has been read by the queue's owner.
  `boolean`
  `isRemotePending()`
  Indicates whether the queued item is waiting for distribution.
  `boolean`
  `isSignOffRequired()`
  Indicates whether a sign off is required for the work item or task.

  ### Methods inherited from interface com.documentum.fc.client.IDfPersistentObject

  `addChildRelative, addParentRelative, apiExec, apiGet, apiSet, destroy, fetch, fetchWithCaching, getAttrAssistance, getAttrAssistanceWithValues, getAttrAsstDependencies, getChildRelatives, getParentRelatives, getPartition, getType, getValidator, getVStamp, getWidgetType, isDeleted, isDirty, isInstanceOf, isNew, isReplica, lock, lockEx, registerEvent, removeChildRelative, removeParentRelative, revert, save, setPartition, signoff, unRegisterEvent, unRegisterEventEx, validateAllRules, validateAttrRules, validateAttrRulesWithValue, validateAttrRulesWithValues, validateObjRules, validateObjRulesWithValues`

  ### Methods inherited from interface com.documentum.fc.client.IDfTypedObject

  `appendBoolean, appendDouble, appendId, appendInt, appendString, appendTime, appendValue, dump, enumAttrs, findAttrIndex, findBoolean, findDouble, findId, findInt, findString, findTime, findValue, getAllRepeatingStrings, getAttr, getAttrCount, getAttrDataType, getBoolean, getDouble, getId, getInt, getLong, getObjectId, getObjectSession, getOriginalSession, getRepeatingBoolean, getRepeatingDouble, getRepeatingId, getRepeatingInt, getRepeatingLong, getRepeatingString, getRepeatingTime, getRepeatingValue, getSession, getSessionManager, getString, getTime, getValue, getValueAt, getValueCount, hasAttr, insertBoolean, insertDouble, insertId, insertInt, insertString, insertTime, insertValue, isAttrRepeating, isNull, remove, removeAll, setBoolean, setDouble, setId, setInt, setNull, setRepeatingBoolean, setRepeatingDouble, setRepeatingId, setRepeatingInt, setRepeatingString, setRepeatingTime, setRepeatingValue, setSessionManager, setString, setTime, setValue, truncate`

- ## Method Details

  - ### getWorkitem

    IDfWorkitem getWorkitem() throws DfException
    Returns the work item object associated with the queue item.

    Queue items can represent work items generated by workflow activities, router tasks, or event notifications. If this queue item was generated by a workflow activity, this method returns the work item object.

    Returns:
      An IDfWorkitem object
    Throws:
      `DfException` - if the server returns an error or the corresponding object is not a work item

  - ### getName

    String getName() throws DfException
    Returns the name of the queue owner.

    The queue owner is the user to whom the queued item was sent. For work items, this is the work item's performer. For router tasks, this is the task's owner. The user may be an individual user or a group.

    For event notifications, this is the user registered to receive the event or the workflow supervisor.

    Returns:
      The queue owner's name
    Throws:
      `DfException` - if the server returns an error

  - ### getStamp

    IDfId getStamp() throws DfException
    Returns the object ID of the queue item object.

    Every work item, task, or event notification that appears in an inbox is stored in the repository as a dmi_queue_item object.

    Returns:
      An IDfId object that contains the queue item's object ID
    Throws:
      `DfException` - if the server returns an error

  - ### getSentBy

    String getSentBy() throws DfException
    Returns the name of the user who sent the work item, task, or event notification.

    Returns:
      The user name. If the item was sent by the system, the returned name is the name of the repository owner.
    Throws:
      `DfException` - if the server returns an error

  - ### getDateSent

    IDfTime getDateSent() throws DfException
    Returns the date the work item, task, or event was sent.

    The date sent is the date on which the item was put in the user's queue (inbox).

    Returns:
      An IDfTime object that contains the date
    Throws:
      `DfException` - if the server returns an error

  - ### getDueDate

    IDfTime getDueDate() throws DfException
    Returns the date on which the associated work item or task is expected to be completed.

    A workflow or router's designer can specify a due date for the activities or tasks. If the queue item represents a work item or task, you can use this method to determine the associated due date if one is defined.

    Returns:
      An IDfTime object that contains the due date. This will be empty if the queue item represents an event notification.
    Throws:
      `DfException` - if the server returns an error

  - ### getEvent

    String getEvent() throws DfException
    Returns the name of the event.

    If the queue item represents an event notificaton, this method returns the name of the event. Otherwise, the method returns an empty string.

    For more information about queuing events and how events function in a workflow, refer to Server Fundamentals.

    Returns:
      The event name or an empty string
    Throws:
      `DfException` - if the server returns an error

  - ### getItemName

    String getItemName() throws DfException
    Returns the name of the package associated with the work item or router task.

    If the queue item represents a work item, this method returns the name of the package associated with that work item. Packages contain the objects on which the work is performed.

    If the queue item represents a router task, this method returns the name of the object being routed.

    Returns:
      The package name or the name of the object being routed. If the queued item is an event notification, this returns an empty string.
    Throws:
      `DfException` - if the server returns an error

  - ### getItemId

    IDfId getItemId() throws DfException
    Returns the object ID of the package or routed object.

    If the queue item represents a work item, this method returns the object ID of the package associated with that work item. Packages contain the objects on which the work is performed.

    If the queue item represents a router task, this method returns the object ID of the object being routed.

    Returns:
      An IDfId object that contains the package or routed object's object ID or an empty string if the queued item is an event notification.
    Throws:
      `DfException` - if the server returns an error

  - ### getItemType

    String getItemType() throws DfException
    Returns the object type of the package or routed object.

    If the queue item represents a work item, this method returns the object type of the package associated with the work item. Packages contain the objects on which the work is performed.

    If the queue item represents a router task, this method returns the type of the object being routed.

    Returns:
      The object type or an empty string if the queued item is an event notification
    Throws:
      `DfException` - if the server returns an error

  - ### getContentType

    String getContentType() throws DfException
    Returns the file format of the object assciated with a router task.

    If the queue item represents a router task, this method returns the file format of the object being routed.

    Returns:
      The file format or an empty string if the queued item is an event notification or a work item
    Throws:
      `DfException` - if the server returns an error

  - ### getMessage

    String getMessage() throws DfException
    Returns the message associated with the work item, task, or event notification.

    The user or application queuing a work item, task, or event notification can provide a message to the recipient.

    Returns:
      The message text. This can be up to 255 characters.
    Throws:
      `DfException` - if the server returns an error

  - ### getRouterId

    IDfId getRouterId() throws DfException
    Returns the object ID of the associated workflow or router.

    If this queue item was generated by a workflow or router or is an event notificaton sent to a workflow supervisor, this method returns the object ID of the workflow or router.

    Routers are pre-4.0 functionality. For information about them, refer to the documentation of previous DocumentumTM releases. For information about router support in 4.0 releases (and above), refer to the Server Migration Guide.

    Returns:
      An IDfId object that contains the object ID. The return value is an empty string if the queued item is an event notification that isn't associated with a workflow.
    Throws:
      `DfException` - if the server returns an error

  - ### getSupervisorName

    String getSupervisorName() throws DfException
    Returns the name of the workflow or router supervisor.

    This method is only useful if the queue item was generated by a workflow or router or if it is an event notification sent to a workflow supervisor.

    For information about workflow supervisors, refer to Server Fundamentals.

    Routers are pre-4.0 functionality. For information about them, refer to the documentation of previous Documentum releases. For information about router support in 4.0 releases (and above), refer to the Server Migration Guide.

    Returns:
      The name of the supervisor. If the queued item is an event notification unrelated to workflow, the return value is an empty string.
    Throws:
      `DfException` - if the server returns an error

  - ### getTaskNumber

    String getTaskNumber() throws DfException
    Returns the activity's sequence number if this is work item or the task number if this is a router task.

    Activities occur in a sequence in a workflow. When the server starts an activity, it assigns the activity a sequence number. This method returns the sequence number of the activity that generated the queue item.

    If this queue item represents a router task, this method returns the task's number in the sequence of router tasks. Routers are pre-4.0 functionality. For information about them, refer to the documentation of previous Documentum releases. For information about router support in 4.0 releases (and above), refer to the Server Migration Guide.

    Returns:
      The sequence number or task number. The return value is an empty string if the queued item is an event notification.
    Throws:
      `DfException` - if the server returns an error

  - ### getTaskName

    String getTaskName() throws DfException
    Returns the value in the task_name attribute.

    If the queued item is a queued event, this method returns "event". If the queued item is a work item, this method returns the name of the activity that generated the work item. If the queued item is router task, this is the name of the task.

    For information about queue items and their attributes, refer to the EMC Documentum Object Reference Manual. For information about how workflows use queue items, refer to Server Fundamentals.

    Routers are pre-4.0 functionality. For information about them, refer to the documentation of previous Documentum releases. For information about router support in 4.0 releases (and above), refer to the Server Migration Guide.

    Returns:
      `event` if the queue item represents a queued event or the activity name if the queue item represents a work item
    Throws:
      `DfException` - if the server returns an error

  - ### getTaskType

    String getTaskType() throws DfException
    Returns the type of the activity or task associated with the queued item.

    An activity's type (begin, step, or end) identifies its relative position within a workflow. Router tasks are also typed as begin, step, or end tasks.

    For a complete description of the types of activities, refer to Server Fundamentals. Routers are pre-4.0 functionality. For information about them, refer to the documentation of previous Documentum releases. For information about router support in 4.0 releases (and above), refer to the Server Migration Guide.

    Returns:
      One of: begin, step, or end for work items or router tasks. For event notifications, this method returns an empty string.
    Throws:
      `DfException` - if the server returns an error

  - ### getTaskState

    String getTaskState() throws DfException
    Returns the state of the associated work item or router task.

    For information about the runtime states of a work item, refer to Server Fundamentals. Routers are pre-4.0 functionality. For information about them, refer to the documentation of previous Documentum releases. For information about router support in 4.0 releases (and above), refer to the Server Migration Guide.

    Returns:
      this method can return of the following:

           dormant
           acquired
           paused
           finished

      For event notifications, this returns an empty string.

    Throws:
      `DfException` - if the server returns an error

  - ### getDependencyType

    String getDependencyType() throws DfException
    Returns the dependency type.

    This method is valid only for queued router tasks. It returns the dependency type of the task.

    Routers are pre-4.0 functionality. For information about them, refer to the documentation of previous Documentum releases. For information about router support in 4.0 releases (and above), refer to the Server Migration Guide.

    Returns:
      The dependency type if the queued item is a router task. If the queued item is a work item or event notification, this returns an empty string.
    Throws:
      `DfException` - if the server returns an error

  - ### getNextTasksType

    String getNextTasksType() throws DfException
    Indicates which tasks in the "next tasks list" are queued when this task is forwarded.

    This method is valid only for queued router tasks. It returns a string that tells you which tasks defined as following this task are selected for queuing. The possible values are `all`, meaning all next tasks are selected; `none`, meaning none of the next tasks are selected; or `decisions`, meaning the current task's performer selects the next tasks at runtime.

    Routers are pre-4.0 functionality. For information about them, refer to the documentation of previous Documentum releases. For information about router support in 4.0 releases (and above), refer to the Server Migration Guide.

    Returns:
      The next tasks type if the queued item is a router task. This method can return one of the following: `all`, `none`, or `decision`. If the queued item is work item or event notification, this returns an empty string.
    Throws:
      `DfException` - if the server returns an error

  - ### getInstructionPage

    int getInstructionPage() throws DfException
    Returns the instruction page's page number.

    This method is valid only for queued router tasks. The method returns the page number of the router's content file that contains instructions for the task's owner.

    Routers are pre-4.0 functionality. For information about them, refer to the documentation of previous Documentum releases. For information about router support in 4.0 releases (and above), refer to the Server Migration Guide.

    Returns:
      The instruction page number. If the queued item is a work item or event notification, this returns an undefined value.
    Throws:
      `DfException` - if the server returns an error

  - ### getPlanStartDate

    IDfTime getPlanStartDate() throws DfException
    Returns the expected starting date of the associated router task.

    This method is valid only for queued router tasks. The router's designer can set a planned starting date for each task in the router. This method returns that date if it is defined for the task.

    Routers are pre-4.0 functionality. For information about them, refer to the documentation of previous Documentum releases. For information about router support in 4.0 releases (and above), refer to the Server Migration Guide.

    Returns:
      An IDfTime object that contains the expected start date. If the queued item is a work item or event notification, the object is empty.
    Throws:
      `DfException` - if the server returns an error

  - ### getActualStartDate

    IDfTime getActualStartDate() throws DfException
    Returns the date on which work on the item actually started.

    This value records the date on which the work item or task was acquired by its performer.

    Returns:
      An IDfTime object that contains the start date. If the queued item hasn't been acquired or is an event notification, the IDfTime object is empty.
    Throws:
      `DfException` - if the server returns an error

  - ### isReadFlag

    boolean isReadFlag() throws DfException
    Indicates whether the queued item has been read by the queue's owner.

    A queue item is considered read if the queue's owner opened and viewed the queue after the item was placed on the queue. For more information about queues and their management, refer to Server Fundamentals.

    Returns:
      `true` if the queue item has been viewed or `false` if it has not
    Throws:
      `DfException` - if the server returns an error

  - ### isDeleteFlag

    boolean isDeleteFlag() throws DfException
    Indicates whether the queued item has been dequeued.

    Dequeuing takes the work item, task, or event notification off the user's queue. The item is no longer visible in the user's inbox. For more information about dequeuing an item, refer to Server Fundamentals.

    Returns:
      `true` if the item is dequeued or `false` if the item is not dequeued
    Throws:
      `DfException` - if the server returns an error

  - ### getPriority

    int getPriority() throws DfException
    Returns the priority of the associated work item or task.

    The priority is a user-defined integer value. For more information about using the priority, refer to Server Fundamentals.

    Returns:
      An integer value that represents the priority. The return value is an undefined value if the item is an event notification.
    Throws:
      `DfException` - if the server returns an error

  - ### getPosition

    double getPosition() throws DfException
    Returns the value in the position attribute.

    This dmi_queue_item attribute is currently unused.

    Returns:
      The value of the position attribute
    Throws:
      `DfException` - if the server returns an error

  - ### getDequeuedBy

    String getDequeuedBy() throws DfException
    Returns the name of the user who dequeued the item.

    Dequeuing a work item, task, or event notification removes the item from the user's inbox. For more information about dequeuing, refer to Server Fundamentals.

    Returns:
      The name of the user who dequeued the item. The return value is an empty string if the item is still queued.
    Throws:
      `DfException` - if the server returns an error

  - ### getDequeuedDate

    IDfTime getDequeuedDate() throws DfException
    Returns the date on which the item was dequeued.

    Dequeuing an item removes the item from the user's inbox. For more information about dequeuing, refer to Server Fundamentals.

    Returns:
      An IDfTime object that contains the dequeue date. The object is empty if the item is still queued.
    Throws:
      `DfException` - if the server returns an error

  - ### isSignOffRequired

    boolean isSignOffRequired() throws DfException
    Indicates whether a sign off is required for the work item or task.

    A workflow or router's designer can require a sign off on activities or tasks. This method returns a Boolean value that indicates whether a sign off is required for the work item or task associated with this queue item.

    Returns:
      `true` if a sign off is required; `false` if not. The return value is undefined if the item is an event notification
    Throws:
      `DfException` - if the server returns an error

  - ### getSignOffUser

    String getSignOffUser() throws DfException
    Returns the name of the user who signed off the item.

    A workflow or router's designer can require a sign off on activities or tasks. If a sign off is required, the work item or task is not considered complete until the user performing it signs off. For more information about signing off workflow activities, refer to Server Fundamentals.

    Returns:
      The name of user who signed off the work item or task. If the sign off hasn't occurred or the item is an event notification, the return value is an empty string.
    Throws:
      `DfException` - if the server returns an error

  - ### getSignOffDate

    IDfTime getSignOffDate() throws DfException
    Returns the date on which the work item or task was signed off.

    A workflow or router's designer can require a sign off on activities or tasks. If a sign off is required, the work item or task is not considered complete until the user performing it signs off. For more information about signing off workflow activities, refer to Server Fundamentals.

    Returns:
      An IDfTime object that contains the sign off date. If the sign off hasn't occurred or the item is an event notification, the IDfTime object is empty.
    Throws:
      `DfException` - if the server returns an error

  - ### getAContentType

    String getAContentType() throws DfException
    Returns the content type of the routed object.

    This method is valid only for router tasks. The method returns the value in the queue item's a_content_type attribute. The value is the name of the file format an application uses when opening the object associated with the task.

    Returns:
      The name of the file format. If the queued item is a work item or event notification, the return value is an empty string.
    Throws:
      `DfException` - if the server returns an error

  - ### getOperations

    String getOperations() throws DfException
    Returns the value in the a_operations attribute of the queue item.

    If the queue item was generated by a workflow activity, this value is the operation defined for the associated package. The operation indicates which application is expected to perform the work associated with the work item.

    If the queue item was generated by a router, this value is user-defined.

    Returns:
      The name of an application or a user-defined value. For event notifications, the return value is an empty string.
    Throws:
      `DfException` - if the server returns an error

  - ### getSourceDocbase

    String getSourceDocbase() throws DfException
    Returns the repository that is the source of the queued object.

    This method only returns a value if the queued item is an object that must be distributed to another repository. You can obtain the name of the target repository (the repository to which the object is sent) using `getTargetDocbase()`.

    Returns:
      The name of the repository. If the item is not a distributed object, the return value is an empty string.
    Throws:
      `DfException` - if the server returns an error

  - ### getTargetDocbase

    String getTargetDocbase() throws DfException
    Returns the name of the target repository.

    This method returns a value only if the queued item is a distributed object. The method returns the name of the repository to which the object is sent.

    Returns:
      The name of the target repository. If the item is not a distributed object, the return value is an empty string.
    Throws:
      `DfException` - if the server returns an error

  - ### isRemotePending

    boolean isRemotePending() throws DfException
    Indicates whether the queued item is waiting for distribution.

    If this method returns `true`, the object associated with the queue item is waiting to be sent to the repository defined as the target repository. To determine the target repository, use `getTargetDocbase()`.

    Returns:
      `true` if the object is waiting to be sent; `false` if the item has been sent. This is an undefined value if the item is not a distributed object
    Throws:
      `DfException` - if the server returns an error

  - ### getSourceEvent

    IDfId getSourceEvent() throws DfException
    Returns the object ID of the queued item in the source repository.

    If this queued item is an object that has been sent to the user from another repository, this method returns the object ID of the dmi_queue_item object in the source repository that generated this queue item.

    For information about distributed workflows, refer to Server Fundamentals.

    Returns:
      An IDfId object that contains the source queue item ID. If the object wasn't sent from another repository, the IDfId object is empty.
    Throws:
      `DfException` - if the server returns an error

  - ### getSourceStamp

    int getSourceStamp() throws DfException
    Returns the vstamp value of the source queue item.

    This method is only valid if the queued item is an object that has been sent to the repository from another repository.

    The vstamp values are used internally to manage versioning.

    Returns:
      The vstamp value. If the item wasn't sent from another repository, the return value is undefined.
    Throws:
      `DfException` - if the server returns an error

  - ### getTaskSubject

    String getTaskSubject() throws DfException
    Returns a subject for the task inbox item
    Throws:
      `DfException`